# Chapter5.py

# Classes and __init__ page 53-54

'''
Application
Factory
PROVIDERS
Services
Classes
 Object
  property (var name with data type) Python -> type implicit wrapper
    = "assigned" value
--> view

functions -> return value to themself -> return keyword
def myCalc():
 x = 7
 y = 3
 z = x + y  # z = 10
 print(z)
methods -> return to something else "classes"
def myCalc(self):
 x = 7
 y = 3
 self.z = x + y  # z = 10
 return z -> last step defines

valueOfmyCalc = myCalc()
'''

'''
What do we use these framework septs for?
? view/output/log/terminal/db/api ... do something {template variable}
<value assigned> Bob
type "firstName" -> firstName as "string"
assignment -> firstName = "Bob" -> variable name firstName as string assign value Bob to property
Obj fullname = firstName + " " + lastName
functions/methods DRY Principle -> Reusable Blocks of Code def fullName():
Class -> Isolate Reusable Blocks of Code from OTHER blocks of code
Services, PROVIDERS, Factories
'''

class Product:

    # define all the pre builds on __init__ of the class
    def __init__(self, param_name, param_price, param_description):
        # productName = name  # variable = param passed  Level 1
        self.attr_name = param_name # attribute of the object<class> = param passed
        self.attr_price = param_price
        self.attr_description = param_description
        # no return keyword, because it is IMplicitly applied by (self)

    # Instance methods and string methods page 56
    ## instance methods create NEW instances of an object in memory. There are other advanced reasons to use instance methods
    def displayProductInfo(self):
        print(f"Product Name: {self.attr_name}.")
        print(f"Product Price: ${self.attr_price:.2f}")
        str_description = f"Product Description: {self.attr_description}."
        print(str_description)

    # string methods allow us to access pro built strings as methods
    def __str__(self): # string is a data type -> Product Class
        str_description = f"Product Description as String Method: {self.attr_description}."
        return str_description  # returning the string<value> to the Object
        # return (self) -> Product Class
        ## __str__<value> = Product Description: Men's Shoes

# SubClass/Inheritance page 60
class ProductDetails(Product): # Injecting the Product Class

    # __init__ Details also use params from Product Class
    def __init__(self, param_name, param_price, param_description, sub_param_color, sub_param_price):
        super().__init__(param_name, param_price, param_description) # Injector
        self.sub_price = sub_param_price # sub class
        self.sub_color = sub_param_color # sub class
        # 7 self objects -> 3 attrs super, 2 methods super, 2 attrs sub
        
# EOF