# Chapter6.py

## Python Standard Imports
# import datetime
import os
import subprocess

from datetime import datetime, timedelta

'''
Python Core -> objects that you get and can use at any time. input() str() int() __init__(), ...

Python Standard -> are install based on the versioning that you download (3.13). Versions both depreciate, update, add and delete objects, methods, ...
3.12 and 3.13 can be VERY VERY different

3 methods for importing Standard Modules
import {ModuleName} 
from {ModuleName} import Object<class, dependency, method, var...>
import {ModuleName} as Namespace/alias 

2 types of Modules/Libraries page 64
High Level Modules -> Low Level Modules
Low Level Modules -> virtualization
'''
class Orders:

    def __init__(self, param_orderID, param_orderDate: datetime, param_orderDueDate: datetime):
        # from datetime import datetime, timedelta  
        # NOT import datetime -> top of file      
        self.attr_orderID = param_orderID
        self.attr_orderDate = param_orderDate 
        self.attr_orderDueDate = param_orderDueDate

    # define an instance method that uses orderDate and orderDueDate in 2 print() lines. Format the date as  01/09/2025. Put the format in its own string
    def orderInformation(self):
        strDateFormat = "%m/%d/%Y"
        print(f"Order Date: {self.attr_orderDate.strftime(strDateFormat)}.")
        # datetime class.strftime -> formats datetime to string
        # datetime class.strptime -> parses ints to datetime (01,08,2025) -> dt
        print(f"Order Due Date: {self.attr_orderDueDate.strftime(strDateFormat)}.")
